<template>
    <div>
        <div class="box activity " v-if="activity.activity">
            <div class="box-header">
                <a v-bind:href="'/user/' + activity.activity.user.id">
                    {{activity.activity.user.username}}
                </a>
                <span>-</span>
                <h1>{{activity.activity.title}}</h1>
            </div>
            <div class="split">
                <div>
                    <p>{{activity.activity.description}}</p>

                </div>

                <div>
                    <p>Distance: {{this.formatDistance(activity['activity']['distance'], activity['activity']['setting_unit'])}}</p>
                    <p>Start: {{activity.activity.start_time}}</p>
                    <p>End: {{activity.activity.end_time}}</p>
                </div>
            </div>
            <div class="button-container" v-if="activity.activity.write_access">
                <a id="delete" class="button" v-on:click="deleteActivity">Delete activity</a>
                <a id="recompute" class="button" v-on:click="recomputeActivity">Recompute Activity</a>
            </div>
        </div>


        <div class="box section-efforts" v-if="activity.activity">
            <div class="box-header">
                <h1>Section Efforts</h1>
            </div>
            <table>
                <tbody class="effort-table">
                    <tr v-for="sectionEffort in activity.activity.section_efforts" v-bind:key="sectionEffort.section_effort.id">
                        <td>
                            <i v-if="sectionEffort.section_effort.achievement === 'new_section'" class="fas fa-certificate new" title="First attempt"/>
                            <i v-if="sectionEffort.section_effort.achievement === 'pr'" class="fas fa-medal gold" title="Personal record"/>
                            <i v-if="sectionEffort.section_effort.achievement === 'second_pr'" class="fas fa-medal silver" title="Second best"/>
                            <i v-if="sectionEffort.section_effort.achievement === 'third_pr'" class="fas fa-medal bronze" title="Third best"/>
                        </td>
                        <td>
                            <a class="effort" v-bind:href="'/section/' + sectionEffort.section_effort.section.id" >
                                {{sectionEffort.section_effort.section.name}} - {{formatTime(sectionEffort.section_effort.time)}}
                            </a>
                        </td>
                    </tr>
                </tbody>
            </table>

            <br>
            <div class="button-container">
                <a v-bind:href="'/section/create/' + activity.activity.id" class="button">Create section</a>
            </div>
        </div>

        <div id="activitymap">

        </div>
    </div>

</template>

<script>
    import L from 'leaflet'
    import omnivore from '@mapbox/leaflet-omnivore'

    let activity = {}

    export default {
        data() {
            return {
                activity
            }
        },
        computed: {
            api_key: function() {
                return this.$store.state.applicationSettings.application_settings
                    .find((setting) => setting.application_setting.code === 'mapbox_api_key')
                    .application_setting.text_value
            }
        },
        methods: {
            deleteActivity: function () {
                this.$store.dispatch('delete_activity', {params: {id: this.$route.params.id}})
                    .then(window.location.replace('/'))
            },
            recomputeActivity: function () {
                this.$store.dispatch('recompute_activity', {params: {id: this.$route.params.id}})
                    .then(location.reload())
            },
            formatTime: function (seconds) {
                // Hours, minutes and seconds
                let hrs = ~~(seconds / 3600);
                let mins = ~~((seconds % 3600) / 60);
                let secs = seconds % 60;

                // Output like "1:01" or "4:03:59" or "123:03:59"
                let ret = "";

                if (hrs > 0) {
                    ret += "" + hrs + ":" + (mins < 10 ? "0" : "");
                }

                ret += "" + mins + ":" + (secs < 10 ? "0" : "");
                ret += "" + secs;
                return ret;
            },
            formatDistance: function (distance, setting_unit) {
                if (setting_unit === 'metric') {
                    return distance.toString() + " km"
                } else {
                    return (distance * 0.62137).toFixed(2) + " mi"
                }
            }
        },
        created: function () {
            this.$store.dispatch('show_activity', {params: {id: this.$route.params.id}}).then(activity => {

                // The bellow is a hack, TODO: implement polling without reloading the page
                if (JSON.parse(activity.request.response).error === 'activity still processing') {
                    window.setTimeout(window.location.reload.bind(window.location), 1000)
                } else {
                    this.activity = activity.data
                    let activitymap = L.map('activitymap').setView([51.505, -0.09], 13)
                    L.tileLayer(`https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token=${this.api_key}`, {
                        attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
                        maxZoom: 18,
                        id: 'mapbox.streets',
                    }).addTo(activitymap)

                    var gpxGroup = new L.FeatureGroup();

                    activitymap.addLayer(gpxGroup);

                    omnivore.gpx(this.activity['activity']['activity_log_url']).addTo(gpxGroup).on('ready',
                        function () {
                            activitymap.fitBounds(gpxGroup.getBounds());
                        }
                    )
                }

            }, response => {
                this.$notify({
                    group: 'error',
                    title: 'Error',
                    duration: -1,
                    text: response.response.data.status + " " + response.response.data.error
                });
            })
        }
    }
</script>

<style>
    #activitymap {
        height: 500px
    }

    .effort {
        display: block
    }


</style>
